#ifndef _KERN_I8259_H
#define _KERN_I8259_H

#include <kern/irq.h>

namespace IRQ {
	class I8259 : public InterruptController {
		u8 cached_masks[2];
		InterruptSlot irqslots[16];
	
		void output_mask(int off);
		void mask(u32 irq);
		void unmask(u32 irq);
		void mask_and_ack(u32 irq);
		int get_pending_irq();

	public:
		void init();
	};

	extern I8259 i8259;
}

#endif
