#ifndef _KERN_TYPES_H
#define _KERN_TYPES_H

#include <lowlevel/types.h>

typedef uint8_t  u8;
typedef uint16_t u16;
typedef uint32_t u32;
typedef uint64_t u64;
typedef int8_t   s8;
typedef int16_t  s16;
typedef int32_t  s32;
typedef int64_t  s64;

typedef u8 octet;

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned long ulong;

static inline bool valid_size_t(u64 size)
{
	void unsupported_size_t();
	
	if (sizeof(size_t) == 8)
		return true;
	
	if (sizeof(size_t) != 4)
		unsupported_size_t();
	
	return (size >> 32) == 0;
}

#endif
